#include <ioavr.h>
#include "stdint.h"
#include <inavr.h>
#include "Common_Define.h"

#ifdef __USI__
	#include "USI_TWI_Slave.c"
	#include "USI_TWI_Slave.h"
#endif

// I޲ƂLAST_INTVECT_ADDRESS`Ԑݒ
/*****************************************************************************/
#ifdef __TWI__
  #if defined(__ATMEGA48__)  | \
	  defined(__ATMEGA48A__) | defined(__ATMEGA48PA__)
	  #define LAST_INTVECT_ADDRESS	SPM_READY_vect	// pނ̊Jn
  #endif

  /*****************************************************************************/
  #if defined(__ATTINY48__) | defined(__ATTINY88__)
    #define LAST_INTVECT_ADDRESS	TWI_vect		// pނ̊Jn
  #endif
  /*****************************************************************************/
#endif

#ifdef __USI__
 /*****************************************************************************/
  #if defined(__ATTINY167__)
	#define LAST_INTVECT_ADDRESS 	USI_START_vect	// pނ̊Jn
  #endif

  #if defined(__ATTINY85__)
	#define LAST_INTVECT_ADDRESS 	USI_OVF_vect	// pނ̊Jn
  #endif
 /*****************************************************************************/

 /*****************************************************************************/
 /*****************************************************************************/
 /*****************************************************************************/
 /*****************************************************************************/
 /*****************************************************************************/
 /*****************************************************************************/
#endif

/*****************************************************************************/
/*****************************************************************************/
#ifdef __TWI__
#define TWI_SLAW_RECEIVED			0x60	// ]uڽƏݖߎM
#define TWI_SLAR_RECEIVED			0xA8	// ]uڽƓǂݍݖߎM
#define TWI_SLAVETX_NACK_RECEIVED	0xC0	// ]uMƔے艞܂͍ŏI޲ď
#define TWI_SLAVERX_ACK_RETURNED	0x80	// ]uMƉԓ
#define TWI_SLAVERX_NACK_RETURNED	0x88	// ]uMƔے艞܂͍ŏI޲ď

#endif

//
uint8_t state = 0;
// __no_init uint8_t pageBuffer[PAGE_SIZE];
uint16_t time_lapse_sec = 0; 
uint8_t volatile gtimeout;
uint8_t statusCode = 0;

/***********************************************************************/

/***********************************************************************/
#ifdef __TWI__
void InitTWI (void)
{

	DDRC &= ~((1 << PORTC5) | (1 << PORTC4));	// SCLSDA͂ƂĐݒ
	PORTC &= ~((1 << PORTC5) | (1 << PORTC4));	// SCLSDALowɐݒ
	// : tiny48,tiny88,mega48TWIɊÂ޲ɑ΂ĈʓIPC4PC5gp܂B

	TWAR = SLAVE_ADDRESS;
	TWCR = (1 << TWEN);
	// A߹ĎM܂ACKȂB

}
#endif
/***********************************************************************/

/***********************************************************************/
//! "ް۰ދ"݂OILowێȂA0ԂB
uint8_t IsBootPinLow (void)
{
	// "ް۰ދ"݂ٱ߂œ͂ł邱Ƃۏ
#if defined(__ATTINY24__)   | defined(__ATTINY24A__) | \
	defined(__ATTINY44__)   | defined(__ATTINY44A__) | \
	defined(__ATTINY84__)   | defined(__ATTINY84A__) | \
	defined(__ATTINY2313__) | defined(__ATTINY2313A__) | \
	defined(__ATTINY4313__) | defined(__ATTINY4313A__) | \
	defined(__ATTINY43U__)  | \
	defined(__ATTINY87__)   | defined(__ATTINY167__) | \
	defined(__ATTINY48__)   | defined(__ATTINY88__) | \
	defined(__ATMEGA48__)   | \
	defined(__ATMEGA48A__)  | defined(__ATMEGA48PA__)

	DDRB &= ~(1 << PORTB0);					// ߰ ݂͂Ƃč쐬
	PORTB |= (1 << PORTB0);
	// ɂB
	__delay_cycles (BOOT_SETTLE_DELAY);
	// ݂Low̏ꍇɔ0ԂB
	return ((PINB & (1 << PORTB0)) == 0);
#endif

#if defined(__ATTINY261__)  | defined(__ATTINY261A__) | \
	defined(__ATTINY461__)  | defined(__ATTINY461A__) | \
	defined(__ATTINY861__)  | defined(__ATTINY861A__) | \
	defined(__ATTINY25__)   | defined(__ATTINY25V__) | \
	defined(__ATTINY45__)   | defined(__ATTINY45V__) | \
	defined(__ATTINY85__)   | defined(__ATTINY85V__)

	DDRB &= ~(1 << PORTB4);					// ߰ ݂͂Ƃč쐬
	PORTB |= (1 << PORTB4);
	// ɂB
	__delay_cycles (BOOT_SETTLE_DELAY);
	// ݂Low̏ꍇɔ0ԂB
	return ((PINB & (1 << PORTB4)) == 0);
#endif
}
/***********************************************************************/

/***********************************************************************/
uint8_t GetStatusCode (void)
{
	// SPM슮
	if ((SPMCSR & (1 << SELFPROGEN)) != 0)
		statusCode |= STATUSMASK_SPMBUSY;

	return statusCode;
}
/***********************************************************************/

/***********************************************************************/
#ifdef __TWI__
void AbortTWI (void)
{
	// ޽J邱ƂɂĈُԂ
	TWCR = (1 << TWINT) | (1 << TWSTO) | (1 << TWEN);
}
#endif
/***********************************************************************/

/***********************************************************************/
#ifdef __TWI__
void ProcessSlaveTransmit (uint8_t data)
{
	// Mpް
	TWDR = data;
	TWCR = (1 << TWINT) | (1 << TWEN);		// ޲đMA呕uNACK\z
	// ҂
	do{} while ((TWCR & (1 << TWINT)) == 0);
	__watchdog_reset ();
	// SLAVETX_NACKɑ΂TWIԕ
	switch (TWSR)
	{
		case TWI_SLAVETX_NACK_RECEIVED:
			// ʐMI
			TWCR = (1 << TWINT) | (1 << TWEN);
			break;

		default:
			AbortTWI ();
	}
}
#endif
/***********************************************************************/

/***********************************************************************/
#ifdef __TWI__
uint8_t SlaveReceiveByteAndACK (uint8_t * data)
{
	// ޲ĂMACKԂB
	TWCR = (1 << TWINT) | (1 << TWEA) | (1 << TWEN);
	// ҂
	do{} while ((TWCR & (1 << TWINT)) == 0);
	__watchdog_reset ();
	// SLAVERX_ACKɑ΂WTIԕ
	switch (TWSR)
	{
		case TWI_SLAVERX_ACK_RETURNED:
			// ޲Ă擾Đɑ΂Ĕ0ԂB
			*data = TWDR;
			return 1;

		default:
			AbortTWI ();
			return 0;
	}
}
#endif
/***********************************************************************/

/***********************************************************************/
#ifdef __TWI__
uint8_t SlaveReceiveByteAndNACK (uint8_t * data)
{
	// ްMNACKԂB
	TWCR = (1 << TWINT) | (1 << TWEN);
	// ҂
	do{} while ((TWCR & (1 << TWINT)) == 0);
	__watchdog_reset ();

	// SLAVERX_ACKɑ΂TWIԕ
	switch (TWSR)
	{
		case TWI_SLAVERX_NACK_RETURNED:
			// ޲Ď擾AʐMIAĐɑ΂Ĕ0ԂB
			*data = TWDR;
			TWCR = (1 << TWINT) | (1 << TWEN);
			return 1;

		default:
			// SLRBANZLEDؾ
			AbortTWI ();
			return 0;
	}
}
#endif
/***********************************************************************/

/***********************************************************************/
/*  ΓIȖ߰ޏE */
void Erase_One_Page (uint16_t addr) 
{
	// ^ꂽڽ߰ޏ
	_SPM_ERASE (addr);

	do{} while ((SPMCSR & (1 << SELFPROGEN)) != 0);
	__DataToR0ByteToSPMCR_SPM (0, ((1 << 4) | (1 << SELFPROGEN)));
	do{} while ((SPMCSR & (1 << SELFPROGEN)) != 0);
}
/***********************************************************************/

/***********************************************************************/
void UpdatePage (uint16_t pageAddress)
{
	// ߰ ڽ ޯĈȊOՕ
	pageAddress &= ~(PAGE_SIZE - 1);
	// ꂪ߰0ȂARESET޸ی
	if (pageAddress == INTVECT_PAGE_ADDRESS)
	{
		// ɏՕɊRESET޸ei[
		pageBuffer[0] =
		__load_program_memory ((void __flash *) (INTVECT_PAGE_ADDRESS + 0));
		pageBuffer[1] =
		__load_program_memory ((void __flash *) (INTVECT_PAGE_ADDRESS + 1));
	}

	// ްė̈XVǂ݂̎
	if (pageAddress < BOOT_PAGE_ADDRESS)
	{
		Erase_One_Page (pageAddress);

		// ꎞ߰ފɏՕݒ
		uint8_t *bufferPtr = pageBuffer;
		uint16_t tempAddress = pageAddress;
		for (uint8_t i = 0; i < PAGE_SIZE; i += 2)
		{
			uint16_t tempWord = ((bufferPtr[1] << 8) | bufferPtr[0]);
			_SPM_FILLTEMP (tempAddress, tempWord);	// ^ꂽްňꎞɏՕ𖞂B
			tempAddress += 2;
			bufferPtr += 2;
		}
		// ꎞɏՕׯ ̗ؓ^ꂽʒu߰ޏ
		_SPM_PAGEWRITE (pageAddress);

//SPMEN//SELFPROGEN

		do{} while ((SPMCSR & (1 << SELFPROGEN)) != 0);					// SPM슮ҋ@
		__DataToR0ByteToSPMCR_SPM (0, ((1 << 4) | (1 << SELFPROGEN)));	// ꎞɏՕ
		do{} while ((SPMCSR & (1 << SELFPROGEN)) != 0);					// SPM슮ҋ@

		__watchdog_reset ();				// ޯ  ؾ
	}
}

/***********************************************************************/

/***********************************************************************/

void ProcessPageUpdate (void)
{
	// SPMAłȂΒ~
	if ((SPMCSR & (1 << SELFPROGEN)) != 0)
	{
#ifdef __TWI__
		AbortTWI ();
#endif

#ifdef __USI__
		USI_TWI_SLAVE_Abort ();
#endif
	}
	else
	{
#ifdef __TWI__
		uint8_t error = 0;
		uint8_t pageAddressLo;
		uint8_t pageAddressHi;
		uint8_t *bufferPtr = pageBuffer;

		// 2޲Ă߰ ڽM
		error = SlaveReceiveByteAndACK (&pageAddressLo) == 0;
		if (!error)
		{
			error = SlaveReceiveByteAndACK (&pageAddressHi) == 0;
		}
		// ߰ ްM
		if (!error)
		{
			for (uint8_t i = 0; i < (PAGE_SIZE - 1); ++i)
			{
				if (SlaveReceiveByteAndACK (bufferPtr) != 0)
				{
					++bufferPtr;
				}
				else
				{
					error = 1;
					break;
				}
			}
		}

		if (!error)
		{
			error = SlaveReceiveByteAndNACK (bufferPtr) == 0;
		}

		// SĂ肭sȂ΍⏑
		if (!error)
		{
			UpdatePage ((pageAddressHi << 8) | pageAddressLo);
		}
#endif
	}
}

/***********************************************************************/

/***********************************************************************/
void Disable_WatchDogTimer (void)
{
/*
	Ԑ菇
	荞݂͊ɋ֎~AȂΎԐ菇Ɋ荞݂̏
	߂ɒǉ̺ނu邩܂B
*/
	asm ("PUSH R24       \n"
		 "PUSH R0        \n"
		 "EOR R0,R0      \n"	// R0=0
		 "LDI R24,0x18   \n"	// WDEWDCEޯĐݒ
		 "WDR            \n"	// ޯ  ؾ
		 "STS 0x0060,R24 \n"	// WDTCSRWDCEWDEݒ
		 "STS 0x0054,R0  \n"	// MCUSRWDRF=0
		 "STS 0x0060,R0  \n"	// WDTCSRWDE=0
		 "POP R0         \n"
		 "POP R24          ");
}

/***********************************************************************/

/***********************************************************************/

void CleanupAndRunApplication (void)
{
	Disable_WatchDogTimer();				// ؾČAWDT̏Ԃ͕ωȂB
	void (*FuncPtr) (void) = (void (*)(void)) ((LAST_INTVECT_ADDRESS + 2) / 2);	// Ō̊荞޸̱ڽɊ֐߲\ݒ
	FuncPtr ();
}

/***********************************************************************/

/***********************************************************************/

void ProcessPageErase (void)
{
	uint16_t addr = 0;
	uint8_t i;

	for (i = 0; i < PAGE_SIZE; ++i)
	{
		pageBuffer[i] = 0xFF;
	}

	UpdatePage (addr);						// ؾ ޸̂
	addr += PAGE_SIZE;

	for (i = 0; i < (LAST_PAGE_NO_TO_BE_ERASED - 1); i++, addr += PAGE_SIZE)
	{
		addr &= ~(PAGE_SIZE - 1);

		if (addr < BOOT_PAGE_ADDRESS)
		Erase_One_Page (addr);				// ް۰ޗ̈܂Ŋe߰ނ1
	}
}

/***********************************************************************/

/***********************************************************************/

void Init_WatchDogTimer (void)
{
/*
	^ꂽ`ԂgtimeoutϐŐݒ肳悤ɳޯ ς
	߂̎Ԑ菇BőœǨĂяoWDTɑ΂ύXƒlݒ
	Ԃ4xN܂B
*/
	asm ("PUSH R0         \n"
		 "PUSH R24        \n"
		 "LDS R0,gtimeout \n"	// ^ꂽݒ擾
		 "LDI R24,0x18    \n"	// WDE,WCE
		 "OR R0,R24       \n"	// WDEWCEݒ
		 "WDR             \n"	// ޯ  ؾ
		 "STS 0x0060,R24  \n"	// ύX
		 "STS 0x0060,R0   \n"	// ύXs
		 "POP R24         \n"
		 "POP R0          \n");
}
/*
// LO = 4C, HI = DE
const uint16_t index_calc[16] = {
	0, 52225, 55297, 5120, 61441, 15360, 10240, 58369,
	40961, 27648, 30720 , 46081, 20480, 39937, 34817, 17408 };
#define MODULO_TWO_SUM( arg1, arg2, arg3)   ( arg1 ^ arg2 ^ arg3 )
void ProcessCRCCheck(void)
{
//
//	CRC_LO <<= ((1 << 2) -1);
//	CRC_HI += 0x5a;
//
	uint16_t crc_sum=0;
	uint16_t j=0;
	unsigned char const __flash * i = ( unsigned char const __flash * ) 2;	// CRCɑ΂ؾ ޸O
	uint8_t data;
	while (i < (unsigned char const __flash *) BOOT_PAGE_ADDRESS )
	{
		data = __load_program_memory(i);
		j=index_calc[crc_sum & 0xF];
		crc_sum = (crc_sum >> 4) & 0x0FFF;
		crc_sum = MODULO_TWO_SUM(crc_sum, j, index_calc[data & 0xF]);

		j= index_calc[crc_sum & 0xF];
		crc_sum = (crc_sum >> 4) & 0x0FFF;
		crc_sum = MODULO_TWO_SUM( crc_sum, j, index_calc[(data >> 4) & 0xF]);

		i++;
	}

	CRC_HI = 0x00FF & (crc_sum >> 8);
	CRC_LO = crc_sum & 0x00FF;
}
*/

/***********************************************************************/

/***********************************************************************/
#ifdef __TWI__
void ProcessSlaveReceive (void)
{
	uint8_t commandCode;

	if (SlaveReceiveByteAndACK (&commandCode) != 0)
	{
		// ޲ď
		switch (commandCode)
		{
			case TWI_CMD_PAGEUPDATE:
				ProcessPageUpdate ();
				break;

			case TWI_CMD_EXECUTEAPP:
				// PɉXTWI呕uɗǂߋU޲ĂNACKǂݍ
				SlaveReceiveByteAndNACK (&commandCode);
				gtimeout = WDT_TIMEOUT_min;	// ؾĂgpĈ|邽߂ɍŏWDTݒ
				Init_WatchDogTimer();		// ύXKp
				while(1);					// WDTؾĂ܂őҋ@

			case TWI_CMD_AVERSION:
				SlaveReceiveByteAndNACK (&commandCode);
				state = 2;
				break;

			case TWI_CMD_BVERSION:
				SlaveReceiveByteAndNACK (&commandCode);
				state = 1;
				break;
/*
			case TWI_CMD_CRCCHECK:
				SlaveReceiveByteAndNACK (&commandCode);
				ProcessCRCCheck();
				state = 3;
				break;
*/
			case TWI_CMD_ERASEFLASH:
				SlaveReceiveByteAndNACK (&commandCode);
				ProcessPageErase ();
				break;

			case TWI_CMD_GETERRCONDN:		// Ԃ̂TWIs
				SlaveReceiveByteAndNACK (&commandCode);
				state = 4;
				break;

			default:
				AbortTWI ();
		}
	}
}
#endif
/***********************************************************************/

/***********************************************************************/
void Read_EEPROM_byte (uint8_t addr, unsigned char *cValue)
{
#ifdef __TWI__
	while (EECR & (1 << EEPE));				// EEPE0ɂȂ܂őҋ@
	EEAR = addr;							// EEPROMڽݒ
	EECR = (1 << EERE);						// ǂݍ݋
	*cValue = EEDR;							// EEPROMްԂB
#endif

#ifdef __USI__
	while (EECR & (1 << EEWE));				// EEWE0ɂȂ܂őҋ@
	EEAR = addr;							// EEPROMڽݒ
	EECR = (1 << EERE);						// ǂݍ݋
	*cValue = EEDR;							// EEPROMްԂB
#endif
}

/***********************************************************************/

/***********************************************************************/
#ifdef __TWI__
void ReadAndProcessPacket (void)
{
	unsigned char temp;

	// ACKAۗ荞݉
	TWCR = (1 << TWINT) | (1 << TWEA) | (1 << TWEN);

	// ҂
	do{ } while ((TWCR & (1 << TWINT)) == 0);

	__watchdog_reset ();

	// SLA+W܂SLA+Rɑ΂TWIԌ
	switch (TWSR)
	{
		case TWI_SLAW_RECEIVED:
			ProcessSlaveReceive ();
			break;

		case TWI_SLAR_RECEIVED:
			if (state == 0)
				ProcessSlaveTransmit (GetStatusCode () & STATUSMASK_SPMBUSY);
			else if (state == 1)
			{
				state = 0;
				ProcessSlaveTransmit (BVERSION);
			}
			else if (state == 2)
			{
				state = 0;
				Read_EEPROM_byte (EEMEM_ADDR_AVERSION, &temp);
				ProcessSlaveTransmit (temp);
			}
			break;

		default:
			AbortTWI ();
	}
}
#endif
/***********************************************************************/

/***********************************************************************/
void Start_Timer (void)
{
#ifdef __TWI__
	TIFR1  = TIFR1;							// ׸މ
	TCNT1H = 0;
	TCNT1L = 0;
	OCR1A  = 7813;							// 7812.5(8MHzۯ1b)
	TCCR1B = _BV (CS12) + _BV (CS10) + _BV (WGM12);	// ԍ4:CTC`ԁA1024Ou
#endif

#ifdef __USI__
	TIFR   = TIFR;							// ׸މ // 
//	TCNT1H = 0;
	TCNT1  = 0;
//	OCR1A  = 7813;							// 7812.5(8MHzۯ1b) //
	OCR1A  = 255;							// 7812.5(8MHzۯ1b) //
	TCCR0A = _BV (WGM01);					// ԍ4:CTC`
	TCCR0B = _BV (CS02) + _BV (CS00);		// 1024Ou
#endif
}

// ARM9 LinuxްĂ߂10bx
#ifdef __TWI__
#define HOST_BOOT_DELAY_SEC 10
#endif

#ifdef __USI__
#define HOST_BOOT_DELAY_SEC 500
#endif

/***********************************************************************/

/***********************************************************************/
void Host_Boot_Delay ()
{
//	time_lapse_sec = 0;

	Start_Timer ();
#ifdef __TWI__
	do{
		if (TIFR1 & _BV (OCF1A))
		{
			time_lapse_sec++;
			TIFR1 = TIFR1;
		}
	}
	while (time_lapse_sec < HOST_BOOT_DELAY_SEC);
	TCCR1B = 0;
	// v~
#endif

	// ̂̂Ō
#ifdef __USI__
	do{
		if (TIFR & _BV (OCF0A))
		{
			time_lapse_sec++;
			TIFR = TIFR;
		}
	}
	while (time_lapse_sec < HOST_BOOT_DELAY_SEC);
	TCCR0B = 0;	
	TCCR0A =0; 
	// v~
#endif
}

/***********************************************************************/

/***********************************************************************/
// (Main)Jn
void main (void)
{
	if (MCUSR & _BV (PORF))					// dONؾĂ̏ꍇ
	{
		MCUSR = 0;

// LED0LED1̪߰ ݂I
#if defined(__ATTINY25__)   | defined(__ATTINY25V__) | \
	defined(__ATTINY45__)   | defined(__ATTINY45V__) | \
	defined(__ATTINY85__)   | defined(__ATTINY85V__) | \
	defined(__ATTINY2313__) | defined(__ATTINY2313A__) | \
	defined(__ATTINY4313__) | defined(__ATTINY4313A__) | \
	defined(__ATTINY261__)  | defined(__ATTINY261A__) | \
	defined(__ATTINY461__)  | defined(__ATTINY461A__) | \
	defined(__ATTINY861__)  | defined(__ATTINY861A__) | \
	defined(__ATTINY43U__)  | \
	defined(__ATTINY87__)   | \
	defined(__ATTINY167__)  | \
	defined(__ATTINY48__)   | defined(__ATTINY88__) | \
	defined(__ATMEGA48__)   | \
	defined(__ATMEGA48A__)  | defined(__ATMEGA48PA__)

	DDRB |= (_BV (1) + _BV (3));			// oLED̪
	PORTB &= ~(_BV (1) + _BV (3));			// LED_
	Host_Boot_Delay ();
	PORTB |= (_BV (1) + _BV (3));			// LED
#endif

#if defined(__ATTINY24__) | defined(__ATTINY24A__) | \
	defined(__ATTINY44__) | defined(__ATTINY44A__) | \
	defined(__ATTINY84__) | defined(__ATTINY84A__)

	DDRB |= (_BV (1) + _BV (2));			// oLED̪
	PORTB &= ~(_BV (1) + _BV (2));			// LED_
	Host_Boot_Delay ();

    PORTB |= (_BV (1) + _BV (2));			// LED
#endif
	}

	if (IsBootPinLow ())
	{
#ifdef __TWI__
		InitTWI();
#endif

#ifdef __USI__
		USI_TWI_SLAVE_Init( SLAVE_ADDRESS );
//		__enable_interrupt();
#endif

		gtimeout = WDT_TIMEOUT_8s;
		Init_WatchDogTimer ();

		while (1)
		{
#ifdef __TWI__
			// TWIߏ
			ReadAndProcessPacket ();
#endif

	#ifdef __USI__
			// TWI߂ɊÂUSI
			USI_TWI_SLAVE_ReadAndProcessPacket ();
#endif
		}
	}
	else
	{
		CleanupAndRunApplication ();
	}
}
