/*****************************************************************************/
#define TWI_CMD_PAGEUPDATE		0x01		// ׯ ߰ނTWI
#define TWI_CMD_EXECUTEAPP		0x02		// p۸т֔TWI
#define TWI_CMD_AVERSION		0x03		// pʎqǂTWI
#define TWI_CMD_BVERSION		0x04		// ް۰މʎq𓾂TWI
#define TWI_CMD_ERASEFLASH		0x05		// ׯ ؂̉p̈ŜTWI
#define TWI_CMD_GETERRCONDN		0x07    	// ȏԂ𓾂TWI

/*****************************************************************************/

#define BOOT_SETTLE_DELAY		100			// MCUłް ݂ɑ΂x
#define SLAVE_ADDRESS			0xb0		// TWI(I2C)޽ł̂̏]u̱ڽʎq
#define INTVECT_PAGE_ADDRESS	0x000		// 荞޸\ڽ̊Jnʒu

// ʐM̪`I: TWI܂USI
#if defined(__ATTINY25__)   | defined(__ATTINY25V__) | \
	defined(__ATTINY45__)   | defined(__ATTINY45V__) | \
	defined(__ATTINY85__)   | defined(__ATTINY85V__) | \
	defined(__ATTINY24__)   | defined(__ATTINY24A__) | \
	defined(__ATTINY44__)   | defined(__ATTINY44A__) | \
	defined(__ATTINY84__)   | defined(__ATTINY84A__) | \
	defined(__ATTINY2313__) | defined(__ATTINY2313A__) | \
	defined(__ATTINY4313__) | defined(__ATTINY4313A__) | \
	defined(__ATTINY261__)  | defined(__ATTINY261A__) | \
	defined(__ATTINY461__)  | defined(__ATTINY461A__) | \
	defined(__ATTINY861__)  | defined(__ATTINY861A__) | \
	defined(__ATTINY43U__)  | \
	defined(__ATTINY87__)   | \
	defined(__ATTINY167__)
	#define __USI__							// ʐM`USIƂĐݒ
#endif

#if defined(__ATTINY48__)  | defined(__ATTINY88__) | \
	defined(__ATMEGA48A__) | defined(__ATMEGA48PA__) | \
	defined(__ATMEGA48__)
	#define __TWI__
#endif

/***************************************************************/

// 2K޲ ׯº۰ׂɑ΂߰ޗeʑI
#if defined(__ATTINY25__)   | defined(__ATTINY25V__) | \
	defined(__ATTINY24__)   | defined(__ATTINY24A__) | \
	defined(__ATTINY2313__) | defined(__ATTINY2313A__) | \
	defined(__ATTINY261__)  | defined(__ATTINY261A__)

	// ޲ɑ΂ׯ  ߰ޗe
	#define PAGE_SIZE					32

	// ߰32Aް۰ޗ̈̊Jn
	#define BOOT_PAGE_ADDRESS			0x0400

	// 32޲ėeʂ߰ނɕ2K޲Ă߰ސ
	#define TOTAL_NO_OF_PAGES			64

	// ް۰ ނɎgp߰ސ
	#define BOOTLOADER_PAGES		(TOTAL_NO_OF_PAGES - BOOT_PAGE_ADDRESS/PAGE_SIZE)

	// sް۰ ނی삷邽߂߰ޓǂ/쒆̋Ep
	#define LAST_PAGE_NO_TO_BE_ERASED	(TOTAL_NO_OF_PAGES - BOOTLOADER_PAGES)
#endif

// 4K޲ ׯº۰ׂɑ΂߰ޗeʑI
#if defined(__ATTINY45__)   | defined(__ATTINY45V__) | \
	defined(__ATTINY44__)   | defined(__ATTINY44A__) | \
	defined(__ATTINY4313__) | defined(__ATTINY4313A__) | \
	defined(__ATTINY461__)  | defined(__ATTINY461A__) | \
	defined(__ATTINY43U__)  | \
	defined(__ATTINY48__)   | \
	defined(__ATMEGA48__)   | \
	defined(__ATMEGA48A__)  | defined(__ATMEGA48PA__)

	// ޲ɑ΂ׯ  ߰ޗe
	#define PAGE_SIZE					64

	// ߰48Aް۰ޗ̈̊Jn
	#define BOOT_PAGE_ADDRESS			0x0C00

	// 64޲ėeʂ߰ނɕ4K޲Ă߰ސ
	#define TOTAL_NO_OF_PAGES			64

	// ް۰ ނɎgp߰ސ
	#define BOOTLOADER_PAGES			(TOTAL_NO_OF_PAGES - BOOT_PAGE_ADDRESS/PAGE_SIZE)

	// sް۰ ނی삷邽߂߰ޓǂ/쒆̋Ep
	#define LAST_PAGE_NO_TO_BE_ERASED	(TOTAL_NO_OF_PAGES - BOOTLOADER_PAGES)
#endif

// 8K޲ ׯº۰ׂɑ΂߰ޗeʑI
#if defined(__ATTINY85__)  | defined(__ATTINY85V__) | \
	defined(__ATTINY84__)  | defined(__ATTINY84A__) | \
	defined(__ATTINY861__) | defined(__ATTINY861A__) | \
	defined(__ATTINY87__)  | \
	defined(__ATTINY88__)

	// ޲ɑ΂ׯ  ߰ޗe
	#define PAGE_SIZE					64

	// ߰112Aް۰ޗ̈̊Jn
	#define BOOT_PAGE_ADDRESS			0x1C00

	// 64޲ėeʂ߰ނɕ8K޲Ă߰ސ
	#define TOTAL_NO_OF_PAGES			128

	// ް۰ ނɎgp߰ސ
	#define BOOTLOADER_PAGES			(TOTAL_NO_OF_PAGES - BOOT_PAGE_ADDRESS/PAGE_SIZE)

	// sް۰ ނی삷邽߂߰ޓǂ/쒆̋Ep
	#define LAST_PAGE_NO_TO_BE_ERASED	(TOTAL_NO_OF_PAGES - BOOTLOADER_PAGES)
#endif

// 16K޲ ׯº۰ׂɑ΂߰ޗeʑI
#if defined(__ATTINY167__)

	// ޲ɑ΂ׯ  ߰ޗe
	#define PAGE_SIZE					128

	// ߰120Aް۰ޗ̈̊Jn
	#define BOOT_PAGE_ADDRESS			0x3C00

	// 128޲ėeʂ߰ނɕ16K޲Ă߰ސ
	#define TOTAL_NO_OF_PAGES			128

	// ް۰ ނɎgp߰ސ
	#define BOOTLOADER_PAGES			(TOTAL_NO_OF_PAGES - BOOT_PAGE_ADDRESS/PAGE_SIZE)

	// sް۰ ނی삷邽߂߰ޓǂ/쒆̋Ep
	#define LAST_PAGE_NO_TO_BE_ERASED	(TOTAL_NO_OF_PAGES - BOOTLOADER_PAGES)

#endif

 /*****************************************************************************/
 /*****************************************************************************/
// ۸ݸނ̂߂̐ޯĖI
#if defined(__ATTINY48__)  | defined(__ATTINY48A__) | \
	defined(__ATTINY88__)  | defined(__ATTINY88A__) | \
	defined(__ATMEGA48__)  | \
	defined(__ATMEGA48A__) | defined(__ATMEGA48PA__)

	#define SELFPROGEN		SELFPRGEN

#endif
 /*****************************************************************************/
 /*****************************************************************************/
#if defined(__ATTINY25__) | defined(__ATTINY25V__) | \
	defined(__ATTINY45__) | defined(__ATTINY45V__) | \
	defined(__ATTINY85__) | defined(__ATTINY85V__) | \
	defined(__ATTINY87__) | defined(__ATTINY167__)

	#define SELFPROGEN		SPMEN

#endif

__no_init uint8_t pageBuffer[PAGE_SIZE];
 /*****************************************************************************/
 /*****************************************************************************/


#define WDT_TIMEOUT_8s		( _BV( WDP3 ) | _BV( WDP0 ) )	// ްė̈ł̕spޯޒߎ
#define WDT_TIMEOUT_16ms	0								// p֔ԑO̼ ؾ(|)pޯޒߎ
#define WDT_TIMEOUT_min		WDT_TIMEOUT_16ms				// p֔Ԃ߂̍ŏޯ ؾĎԊԊu

/*****************************************************************************/
/*****************************************************************************/

#define STATUSMASK_SPMBUSY			0x01	// SPMZԕpՕޯ
#define STATUSMASK_BLSCERR			0x02	// ް۰ޗ̈㏑spՕޯ
#define STATUSMASK_TWIABORT			0x04	// Ăяo֐łTWIf߂̎Օޯ
#define STATUSMASK_SLTR_BUSY		0x08	// ]uMpՕޯ
#define STATUSMASK_SLRBAA_BUSY		0x10	// ]uMACKpՕޯ
#define STATUSMASK_SLRBAN_BUSY		0x20	// ]uMNACKpՕޯ
#define STATUSMASK_EEPROM_BUSY		0x40	// EEPROMZpՕޯ
#define STATUSMASK_BOOTLOADER		0x80	// ް۰ޑpՕޯ
/*****************************************************************************/
/*****************************************************************************/

#define EEMEM_ADDR_AVERSION			0x05	// pʎqi[EEPROM̱ڽ
#define BVERSION					0x96	// ް۰ނ̉ʎq

void UpdatePage (uint16_t);

#ifndef _BV
#define _BV( __BIT_POSITION__ ) ( 1 << __BIT_POSITION__ )
#endif

#ifdef _BV
#warning _BV now stands defined
#endif
